Bug 1229261 - data tiering: do not allow tiering related volume set options on a regular volume
Summary: data tiering: do not allow tiering related volume set options on a regular vo...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: tier
Version: rhgs-3.1
Hardware: Unspecified
OS: Unspecified
high
low
Target Milestone: ---
: RHGS 3.1.0
Assignee: Mohammed Rafi KC
QA Contact: Nag Pavan Chilakam
URL:
Whiteboard:
Depends On: 1216960 1230560
Blocks: 1202842
TreeView+ depends on / blocked
 
Reported: 2015-06-08 10:40 UTC by Nag Pavan Chilakam
Modified: 2016-09-17 15:36 UTC (History)
10 users (show)

Fixed In Version: glusterfs-3.7.1-5
Doc Type: Bug Fix
Doc Text:
Clone Of: 1216960
Environment:
Last Closed: 2015-07-29 04:59:08 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2015:1495 0 normal SHIPPED_LIVE Important: Red Hat Gluster Storage 3.1 update 2015-07-29 08:26:26 UTC

Description Nag Pavan Chilakam 2015-06-08 10:40:42 UTC
+++ This bug was initially created as a clone of Bug #1216960 +++

Description of problem:
======================
Currently user is able to set tiering volume set options even on a regular volume. This should be disallowed
Volume Name: regv1
Type: Distribute
Volume ID: bcbb83b1-5a54-4315-acd9-1d7830f0fa00
Status: Started
Number of Bricks: 1
Transport-type: tcp
Bricks:
Brick1: yarrow:/brick_100G_9/regv1
Options Reconfigured:
cluster.tier-demote-frequency: 120
cluster.tier-promote-frequency: 120
features.ctr-enabled: on


Version-Release number of selected component (if applicable):
==========================================================
[root@yarrow glusterfs]# gluster --version
glusterfs 3.7.0alpha0 built on Apr 28 2015 01:37:11
Repository revision: git://git.gluster.com/glusterfs.git
Copyright (c) 2006-2011 Gluster Inc. <http://www.gluster.com>
GlusterFS comes with ABSOLUTELY NO WARRANTY.
You may redistribute copies of GlusterFS under the terms of the GNU General Public License.
[root@yarrow glusterfs]# rpm -qa|grep gluster
glusterfs-fuse-3.7.0alpha0-0.17.gited96153.el7.centos.x86_64
glusterfs-libs-3.7.0alpha0-0.17.gited96153.el7.centos.x86_64
glusterfs-3.7.0alpha0-0.17.gited96153.el7.centos.x86_64
glusterfs-cli-3.7.0alpha0-0.17.gited96153.el7.centos.x86_64
glusterfs-server-3.7.0alpha0-0.17.gited96153.el7.centos.x86_64
glusterfs-api-3.7.0alpha0-0.17.gited96153.el7.centos.x86_64



Steps to Reproduce:
===================
1.create a regular volume like dist-rep or distribute volume 
2.set tiering related options like "features.ctr-enabled" to on
cluster.tier-demote-frequency to some value


these should be disallowed....as they are meant for tiered volume only

--- Additional comment from Anand Avati on 2015-05-11 05:16:50 EDT ---

REVIEW: http://review.gluster.org/10751 (tier/volume set: Validate volume set option for tier) posted (#1) for review on master by mohammed rafi  kc (rkavunga@redhat.com)

--- Additional comment from Anand Avati on 2015-05-29 03:18:17 EDT ---

REVIEW: http://review.gluster.org/10751 (tier/volume set: Validate volume set option for tier) posted (#2) for review on master by mohammed rafi  kc (rkavunga@redhat.com)

--- Additional comment from Anand Avati on 2015-06-03 10:52:46 EDT ---

REVIEW: http://review.gluster.org/10751 (tier/volume set: Validate volume set option for tier) posted (#3) for review on master by mohammed rafi  kc (rkavunga@redhat.com)

Comment 2 Joseph Elwin Fernandes 2015-06-15 10:54:34 UTC
Downstream patch:
https://code.engineering.redhat.com/gerrit/50617

Comment 5 Vivek Agarwal 2015-06-22 08:12:32 UTC
moving back to modified, was moved to on_qa by errata tool.

Comment 8 Triveni Rao 2015-06-24 07:31:58 UTC
i could reproduce this problem:

[root@rhsqa14-vm1 ~]# gluster v create pest replica 2 10.70.47.165:/rhs/brick1/p0 10.70.47.163:/rhs/brick1/p0 10.70.47.165:/rhs/brick2/p0 10.70.47.163:/rhs/brick2/p0 
volume create: pest: success: please start the volume to access data
[root@rhsqa14-vm1 ~]# gluster v start pest
volume start: pest: success
[root@rhsqa14-vm1 ~]# 
[root@rhsqa14-vm1 ~]# gluster v set pest cluster.tier-demote-frequency 10
volume set: success
[root@rhsqa14-vm1 ~]# gluster v set pest cluster.tier-promote-frequency 10
volume set: success
[root@rhsqa14-vm1 ~]# gluster v set pest features.ctr-enabled
Usage: volume set <VOLNAME> <KEY> <VALUE>
[root@rhsqa14-vm1 ~]# gluster v set pest features.ctr-enabled on
volume set: success
[root@rhsqa14-vm1 ~]# gluster v info pest
 
Volume Name: pest
Type: Distributed-Replicate
Volume ID: a80f568b-0a9a-4d8e-bed0-b6fabe9fbdc8
Status: Started
Number of Bricks: 2 x 2 = 4
Transport-type: tcp
Bricks:
Brick1: 10.70.47.165:/rhs/brick1/p0
Brick2: 10.70.47.163:/rhs/brick1/p0
Brick3: 10.70.47.165:/rhs/brick2/p0
Brick4: 10.70.47.163:/rhs/brick2/p0
Options Reconfigured:
features.ctr-enabled: on
cluster.tier-promote-frequency: 10
cluster.tier-demote-frequency: 10
performance.readdir-ahead: on
[root@rhsqa14-vm1 ~]# 


[root@rhsqa14-vm1 ~]# rpm -qa | grep gluster
gluster-nagios-addons-0.2.3-1.el6rhs.x86_64
glusterfs-fuse-3.7.1-4.el6rhs.x86_64
glusterfs-geo-replication-3.7.1-4.el6rhs.x86_64
gluster-nagios-common-0.2.0-1.el6rhs.noarch
glusterfs-libs-3.7.1-4.el6rhs.x86_64
glusterfs-client-xlators-3.7.1-4.el6rhs.x86_64
glusterfs-api-3.7.1-4.el6rhs.x86_64
glusterfs-server-3.7.1-4.el6rhs.x86_64
glusterfs-rdma-3.7.1-4.el6rhs.x86_64
vdsm-gluster-4.16.20-1.1.el6rhs.noarch
glusterfs-3.7.1-4.el6rhs.x86_64
glusterfs-cli-3.7.1-4.el6rhs.x86_64
[root@rhsqa14-vm1 ~]#

Comment 9 Vivek Agarwal 2015-06-24 07:39:47 UTC
why are you trying with build -3.7.1-4 while we have a new build -3.7.1-5 today.

Comment 11 Triveni Rao 2015-06-24 11:31:49 UTC
[root@rhsqa14-vm1 ~]# gluster v info good
 
Volume Name: good
Type: Distributed-Replicate
Volume ID: 9425c6b8-a7e3-49df-a354-fa4d572507bc
Status: Started
Number of Bricks: 2 x 2 = 4
Transport-type: tcp
Bricks:
Brick1: 10.70.47.165:/rhs/brick1/g0
Brick2: 10.70.47.163:/rhs/brick1/g0
Brick3: 10.70.47.165:/rhs/brick2/g0
Brick4: 10.70.47.163:/rhs/brick2/g0
Options Reconfigured:
performance.readdir-ahead: on
[root@rhsqa14-vm1 ~]# gluster v set good cluster.tier-demote-frequency 10
volume set: failed: Volume good is not a tier volume. Option cluster.tier-demote-frequency is only valid for tier volume.
[root@rhsqa14-vm1 ~]# gluster v set good cluster.tier-promote-frequency 10
volume set: failed: Volume good is not a tier volume. Option cluster.tier-promote-frequency is only valid for tier volume.
[root@rhsqa14-vm1 ~]# gluster v set good features.ctr-enabled on
volume set: success
[root@rhsqa14-vm1 ~]# 


i see that feature.ctr-enabled can be applied on regular volume.
please confirm about ctr value.

Comment 12 Mohammed Rafi KC 2015-06-24 12:30:27 UTC
I considered tiering related volume set commands as everything which starts with "cluster.tier". IMHO, ctr is implemented as a stand alone xlator, so restricting the ctr xlator only for tiering is not good.

Comment 13 Triveni Rao 2015-06-25 11:19:20 UTC
with above explanation regarding the ctr option this bug is verified.

Comment 14 errata-xmlrpc 2015-07-29 04:59:08 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2015-1495.html


Note You need to log in before you can comment on or make changes to this bug.